#line 1 "E:/Mes_documents/Electronique/Pic/Mikroelektronika/mikroC PRO for PIC/Ready for PIC/DAC for VCF Generator (SPI)/P18F25K22/09B4478819/DAC_VCF_SPI.c"
#line 1 "e:/mes_documents/electronique/pic/mikroelektronika/mikroc pro for pic/ready for pic/dac for vcf generator (spi)/p18f25k22/09b4478819/init_lcd adaptator 2x16_p18f45k22_portb.h"


sbit LCD_RS at LATB2_bit;
sbit LCD_EN at LATB3_bit;
sbit LCD_D4 at LATB4_bit;
sbit LCD_D5 at LATB5_bit;
sbit LCD_D6 at LATB6_bit;
sbit LCD_D7 at LATB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
#line 48 "E:/Mes_documents/Electronique/Pic/Mikroelektronika/mikroC PRO for PIC/Ready for PIC/DAC for VCF Generator (SPI)/P18F25K22/09B4478819/DAC_VCF_SPI.c"
sbit Chip_Select at LATC1_bit;
sbit Chip_Select_Direction at TRISC1_bit;


unsigned int value, adc_rd, adc_ldr, data_, temp, High_Data, Low_Data, value_temp, cnt, speed_delay;
unsigned char ch, val;
char *text;
long tlong;
unsigned long k;
char ii;
unsigned short current_duty;
#line 78 "E:/Mes_documents/Electronique/Pic/Mikroelektronika/mikroC PRO for PIC/Ready for PIC/DAC for VCF Generator (SPI)/P18F25K22/09B4478819/DAC_VCF_SPI.c"
void delay2S(){
 Delay_ms(2000);
}

void InitMain() {
 TRISA0_bit = 1;
 TRISA1_bit = 1;
 TRISA3_bit = 1;
 TRISA4_bit = 1;
 TRISA5_bit = 1;
 Chip_Select = 1;
 Chip_Select_Direction = 0;
 SPI1_Init();
 PWM1_Init(5000);





 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
 text = "Initializing...";
 Lcd_Out(1,1,text);
 Delay_ms(500);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"VCF Generator");
 text = "DAC on LCD";
 Lcd_Out(2,2,text);
 Delay_ms(1000);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"Reading EEPROM");
 Lcd_Out(2,1,"from PIC...");
 Delay_ms(1000);
 Lcd_Cmd(_LCD_CLEAR);
 text = "Output Voltage";
 Lcd_Out(1,1,text);
 Delay_ms(250);
 text = "for VCF:";
}

void Write_EEPROM(unsigned int data_) {

 High_Data = (data_ >> 8) & 0x0F;
 EEPROM_Write(0x08,High_Data);


 Low_Data = data_;
 EEPROM_Write(0x09,Low_Data);
}


void DAC_Output(unsigned int valueDAC) {
 Chip_Select = 0;


 temp = (valueDAC >> 8) & 0x0F;
 temp |= 0x30;
 SPI1_Write(temp);


 temp = valueDAC;
 SPI1_Write(temp);

 Chip_Select = 1;
}

void Display_speed_delay() {
 val = ((speed_delay / 1000) % 10) ;
 Lcd_Chr(1,12,48+val);
 val = ((speed_delay / 100) % 10) ;
 Lcd_Chr_CP(48+val);
 val = ((speed_delay / 10) % 10) ;
 Lcd_Chr_CP(48+val);
 val = (speed_delay % 10) ;
 Lcd_Chr_CP(48+val);

 Lcd_Out(1,1,"Delay(ms): ");
 Delay_ms(2000);
 Lcd_Out(1,1,"Output Voltage  ");
}

void main() {
 ANSELA = 0;


 ANSELC = 0;
 SLRCON = 0;

 InitMain();
 current_duty = 16;
 PWM1_Start();
 PWM1_Set_Duty(current_duty);

 cnt == 4;


 High_Data = EEPROM_Read(0x08);


 Low_Data = EEPROM_Read(0x09);
 value = (High_Data << 8) | (unsigned int)Low_Data;



 while (1) {

 adc_ldr = ADC_Read(0);
 if (adc_ldr < 3) {
 adc_ldr = 3;
 }
 if (( (RA3_bit == 1) ) && (value < 4095)) {
 value++;
 Write_EEPROM(value);
 }
 else {
 if (( (RA4_bit == 1) ) && (value > 0)) {
 value--;
 Write_EEPROM(value);
 }
 }
 if ( (RA3_bit && RA4_bit == 1)  == 1) {
 value = 4095;
 Write_EEPROM(value);
 }
 if ( (RA5_bit == 1)  == 1) {
 value = 0;
 Write_EEPROM(value);
 }

 DAC_Output(value);

 if ( (RA1_bit == 1) ) {
 Display_speed_delay();
 ++cnt;

 while( (RA1_bit == 1) );

 }
 if (cnt > 5) {
 cnt = 0;
 Delay_ms(1);
 speed_delay = 1;
 }
 else
 if (cnt == 0) {
 Delay_ms(1);
 speed_delay = 1;
 }
 if (cnt == 1) {
 Delay_ms(10);
 speed_delay = 10;
 }
 if (cnt == 2) {
 Delay_ms(50);
 speed_delay = 50;
 }
 if (cnt == 3) {
 Delay_ms(250);
 speed_delay = 250;
 }
 if (cnt == 4) {
 Delay_ms(500);
 speed_delay = 500;
 }
 if (cnt == 5) {
 Delay_ms(1000);
 speed_delay = 1000;
 }
#line 258 "E:/Mes_documents/Electronique/Pic/Mikroelektronika/mikroC PRO for PIC/Ready for PIC/DAC for VCF Generator (SPI)/P18F25K22/09B4478819/DAC_VCF_SPI.c"
 current_duty = adc_ldr * 1.5;
 PWM1_Set_Duty(current_duty);



 adc_rd = value;
 Lcd_Out(2,1,text);
 tlong = (long)adc_rd * 5000;

 k = 1.221001221;
 tlong = (tlong / 4095) * k;
 ch = tlong / 1000;

 ch = ((tlong / 1000) % 10) ;
 Lcd_Chr(2,10,48+ch);
 ch = ((tlong / 100) % 10) ;
 Lcd_Chr_CP(48+ch);
 ch = ((tlong / 10) % 10) ;
 Lcd_Chr_CP(48+ch);
 ch = (tlong % 10) ;
 Lcd_Chr_CP(48+ch);
 Lcd_Out_CP("mV");
 }
}
