
_delay2S:

;DAC_VCF_SPI.c,78 :: 		void delay2S(){                                      // 2 seconds delay function
;DAC_VCF_SPI.c,79 :: 		Delay_ms(2000);
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_delay2S0:
	DECFSZ      R13, 1, 1
	BRA         L_delay2S0
	DECFSZ      R12, 1, 1
	BRA         L_delay2S0
	DECFSZ      R11, 1, 1
	BRA         L_delay2S0
	NOP
;DAC_VCF_SPI.c,80 :: 		}
L_end_delay2S:
	RETURN      0
; end of _delay2S

_InitMain:

;DAC_VCF_SPI.c,82 :: 		void InitMain() {
;DAC_VCF_SPI.c,83 :: 		TRISA0_bit = 1;                                    // Set RA0 pin as input (for LDR detection)
	BSF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
;DAC_VCF_SPI.c,84 :: 		TRISA1_bit = 1;                                    // Set RA1 pin as input (key for DAC_delay)
	BSF         TRISA1_bit+0, BitPos(TRISA1_bit+0) 
;DAC_VCF_SPI.c,85 :: 		TRISA3_bit = 1;                                    // Set RA3 pin as input (key for increment)
	BSF         TRISA3_bit+0, BitPos(TRISA3_bit+0) 
;DAC_VCF_SPI.c,86 :: 		TRISA4_bit = 1;                                    // Set RA4 pin as input (key for decrement)
	BSF         TRISA4_bit+0, BitPos(TRISA4_bit+0) 
;DAC_VCF_SPI.c,87 :: 		TRISA5_bit = 1;                                    // Set RA5 pin as input (key for reset value to 0)
	BSF         TRISA5_bit+0, BitPos(TRISA5_bit+0) 
;DAC_VCF_SPI.c,88 :: 		Chip_Select = 1;                                   // Deselect DAC
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;DAC_VCF_SPI.c,89 :: 		Chip_Select_Direction = 0;                         // Set CS# pin as Output
	BCF         TRISC1_bit+0, BitPos(TRISC1_bit+0) 
;DAC_VCF_SPI.c,90 :: 		SPI1_Init();                                       // Initialize SPI module
	CALL        _SPI1_Init+0, 0
;DAC_VCF_SPI.c,91 :: 		PWM1_Init(5000);                                   // Initialize PWM1 module at 5KHz
	BSF         T2CON+0, 0, 0
	BSF         T2CON+0, 1, 0
	MOVLW       99
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;DAC_VCF_SPI.c,97 :: 		Lcd_Init();                                        // LCD display initialization
	CALL        _Lcd_Init+0, 0
;DAC_VCF_SPI.c,98 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);                          // LCD command (cursor off)
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;DAC_VCF_SPI.c,99 :: 		Lcd_Cmd(_LCD_CLEAR);                               // LCD command (clear LCD)
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;DAC_VCF_SPI.c,100 :: 		text = "Initializing...";                          // Define the first message
	MOVLW       ?lstr1_DAC_VCF_SPI+0
	MOVWF       _text+0 
	MOVLW       hi_addr(?lstr1_DAC_VCF_SPI+0)
	MOVWF       _text+1 
;DAC_VCF_SPI.c,101 :: 		Lcd_Out(1,1,text);
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        _text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,102 :: 		Delay_ms(500);
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_InitMain1:
	DECFSZ      R13, 1, 1
	BRA         L_InitMain1
	DECFSZ      R12, 1, 1
	BRA         L_InitMain1
	DECFSZ      R11, 1, 1
	BRA         L_InitMain1
	NOP
;DAC_VCF_SPI.c,103 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;DAC_VCF_SPI.c,104 :: 		Lcd_Out(1,1,"VCF Generator");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,105 :: 		text = "DAC on LCD";                               // Define the first message
	MOVLW       ?lstr3_DAC_VCF_SPI+0
	MOVWF       _text+0 
	MOVLW       hi_addr(?lstr3_DAC_VCF_SPI+0)
	MOVWF       _text+1 
;DAC_VCF_SPI.c,106 :: 		Lcd_Out(2,2,text);                                 // Write the first message in the first line
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        _text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,107 :: 		Delay_ms(1000);
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_InitMain2:
	DECFSZ      R13, 1, 1
	BRA         L_InitMain2
	DECFSZ      R12, 1, 1
	BRA         L_InitMain2
	DECFSZ      R11, 1, 1
	BRA         L_InitMain2
;DAC_VCF_SPI.c,108 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;DAC_VCF_SPI.c,109 :: 		Lcd_Out(1,1,"Reading EEPROM");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,110 :: 		Lcd_Out(2,1,"from PIC...");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr5_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr5_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,111 :: 		Delay_ms(1000);
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_InitMain3:
	DECFSZ      R13, 1, 1
	BRA         L_InitMain3
	DECFSZ      R12, 1, 1
	BRA         L_InitMain3
	DECFSZ      R11, 1, 1
	BRA         L_InitMain3
;DAC_VCF_SPI.c,112 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;DAC_VCF_SPI.c,113 :: 		text = "Output Voltage";                           // Define the second message
	MOVLW       ?lstr6_DAC_VCF_SPI+0
	MOVWF       _text+0 
	MOVLW       hi_addr(?lstr6_DAC_VCF_SPI+0)
	MOVWF       _text+1 
;DAC_VCF_SPI.c,114 :: 		Lcd_Out(1,1,text);                                 // Define the first message
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        _text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,115 :: 		Delay_ms(250);
	MOVLW       11
	MOVWF       R11, 0
	MOVLW       38
	MOVWF       R12, 0
	MOVLW       93
	MOVWF       R13, 0
L_InitMain4:
	DECFSZ      R13, 1, 1
	BRA         L_InitMain4
	DECFSZ      R12, 1, 1
	BRA         L_InitMain4
	DECFSZ      R11, 1, 1
	BRA         L_InitMain4
	NOP
	NOP
;DAC_VCF_SPI.c,116 :: 		text = "for VCF:";                                 // Define the third message
	MOVLW       ?lstr7_DAC_VCF_SPI+0
	MOVWF       _text+0 
	MOVLW       hi_addr(?lstr7_DAC_VCF_SPI+0)
	MOVWF       _text+1 
;DAC_VCF_SPI.c,117 :: 		}
L_end_InitMain:
	RETURN      0
; end of _InitMain

_Write_EEPROM:

;DAC_VCF_SPI.c,119 :: 		void Write_EEPROM(unsigned int data_) {
;DAC_VCF_SPI.c,121 :: 		High_Data = (data_ >> 8) & 0x0F;                  // Write value[11..8] to High_Data[3..0] at address 8 (poids fort)
	MOVF        FARG_Write_EEPROM_data_+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       15
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       _High_Data+0 
	MOVF        R1, 0 
	MOVWF       _High_Data+1 
;DAC_VCF_SPI.c,122 :: 		EEPROM_Write(0x08,High_Data);
	MOVLW       8
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;DAC_VCF_SPI.c,125 :: 		Low_Data = data_;                                 // Write value[7..0] to Low_Data[7..0] at address 9 (poids faible)
	MOVF        FARG_Write_EEPROM_data_+0, 0 
	MOVWF       _Low_Data+0 
	MOVF        FARG_Write_EEPROM_data_+1, 0 
	MOVWF       _Low_Data+1 
;DAC_VCF_SPI.c,126 :: 		EEPROM_Write(0x09,Low_Data);
	MOVLW       9
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        FARG_Write_EEPROM_data_+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;DAC_VCF_SPI.c,127 :: 		}
L_end_Write_EEPROM:
	RETURN      0
; end of _Write_EEPROM

_DAC_Output:

;DAC_VCF_SPI.c,130 :: 		void DAC_Output(unsigned int valueDAC) {
;DAC_VCF_SPI.c,131 :: 		Chip_Select = 0;                                   // Select DAC chip
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;DAC_VCF_SPI.c,134 :: 		temp = (valueDAC >> 8) & 0x0F;                     // Store valueDAC[11..8] to temp[3..0]
	MOVF        FARG_DAC_Output_valueDAC+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       15
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       _temp+0 
	MOVF        R1, 0 
	MOVWF       _temp+1 
;DAC_VCF_SPI.c,135 :: 		temp |= 0x30;                                      // Define DAC setting, see MCP4921 datasheet
	MOVLW       48
	IORWF       R0, 1 
	MOVLW       0
	IORWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       _temp+0 
	MOVF        R1, 0 
	MOVWF       _temp+1 
;DAC_VCF_SPI.c,136 :: 		SPI1_Write(temp);                                  // Send high byte via SPI
	MOVF        R0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;DAC_VCF_SPI.c,139 :: 		temp = valueDAC;                                   // Store valueDAC[7..0] to temp[7..0]
	MOVF        FARG_DAC_Output_valueDAC+0, 0 
	MOVWF       _temp+0 
	MOVF        FARG_DAC_Output_valueDAC+1, 0 
	MOVWF       _temp+1 
;DAC_VCF_SPI.c,140 :: 		SPI1_Write(temp);                                  // Send low byte via SPI
	MOVF        FARG_DAC_Output_valueDAC+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;DAC_VCF_SPI.c,142 :: 		Chip_Select = 1;                                   // Deselect DAC chip
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;DAC_VCF_SPI.c,143 :: 		}
L_end_DAC_Output:
	RETURN      0
; end of _DAC_Output

_Display_speed_delay:

;DAC_VCF_SPI.c,145 :: 		void Display_speed_delay() {
;DAC_VCF_SPI.c,146 :: 		val = ((speed_delay / 1000) % 10) ;              // Extract thousands
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVF        _speed_delay+0, 0 
	MOVWF       R0 
	MOVF        _speed_delay+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       _val+0 
;DAC_VCF_SPI.c,147 :: 		Lcd_Chr(1,12,48+val);                            // Write result in ASCII format
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;DAC_VCF_SPI.c,148 :: 		val = ((speed_delay / 100) % 10) ;               // Extract hundreds
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _speed_delay+0, 0 
	MOVWF       R0 
	MOVF        _speed_delay+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       _val+0 
;DAC_VCF_SPI.c,149 :: 		Lcd_Chr_CP(48+val);                              // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,150 :: 		val = ((speed_delay / 10) % 10) ;                // Extract tens of millivolts
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _speed_delay+0, 0 
	MOVWF       R0 
	MOVF        _speed_delay+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       _val+0 
;DAC_VCF_SPI.c,151 :: 		Lcd_Chr_CP(48+val);                              // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,152 :: 		val = (speed_delay % 10) ;                       // Extract units
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _speed_delay+0, 0 
	MOVWF       R0 
	MOVF        _speed_delay+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       _val+0 
;DAC_VCF_SPI.c,153 :: 		Lcd_Chr_CP(48+val);                              // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,155 :: 		Lcd_Out(1,1,"Delay(ms): ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr8_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr8_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,156 :: 		Delay_ms(2000);
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_Display_speed_delay5:
	DECFSZ      R13, 1, 1
	BRA         L_Display_speed_delay5
	DECFSZ      R12, 1, 1
	BRA         L_Display_speed_delay5
	DECFSZ      R11, 1, 1
	BRA         L_Display_speed_delay5
	NOP
;DAC_VCF_SPI.c,157 :: 		Lcd_Out(1,1,"Output Voltage  ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr9_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr9_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,158 :: 		}
L_end_Display_speed_delay:
	RETURN      0
; end of _Display_speed_delay

_main:

;DAC_VCF_SPI.c,160 :: 		void main() {
;DAC_VCF_SPI.c,161 :: 		ANSELA = 0;                                        // Configure PORTA pins as digital
	CLRF        ANSELA+0 
;DAC_VCF_SPI.c,164 :: 		ANSELC = 0;                                        // Configure PORTC pins as digital
	CLRF        ANSELC+0 
;DAC_VCF_SPI.c,165 :: 		SLRCON = 0;                                        // Set output slew rate on all ports at standard rate
	CLRF        SLRCON+0 
;DAC_VCF_SPI.c,167 :: 		InitMain();                                        // Perform main initialization
	CALL        _InitMain+0, 0
;DAC_VCF_SPI.c,168 :: 		current_duty  = 16;                                // initial value for current_duty
	MOVLW       16
	MOVWF       _current_duty+0 
;DAC_VCF_SPI.c,169 :: 		PWM1_Start();                                      // start PWM1 (RC1)
	CALL        _PWM1_Start+0, 0
;DAC_VCF_SPI.c,170 :: 		PWM1_Set_Duty(current_duty);                       // Set current duty for PWM1
	MOVF        _current_duty+0, 0 
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;DAC_VCF_SPI.c,175 :: 		High_Data = EEPROM_Read(0x08);                     // Read value from High_Data[7..0] at address 8 (MSB)
	MOVLW       8
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _High_Data+0 
	MOVLW       0
	MOVWF       _High_Data+1 
;DAC_VCF_SPI.c,178 :: 		Low_Data = EEPROM_Read(0x09);                      // Read value from Low_Data[7..0] at address 9 (LSB)
	MOVLW       9
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _Low_Data+0 
	MOVLW       0
	MOVWF       _Low_Data+1 
;DAC_VCF_SPI.c,179 :: 		value = (High_Data << 8) | (unsigned int)Low_Data; // Moves the 8-bits to the left, and make a bitwise (inclusive) OR
	MOVF        _High_Data+0, 0 
	MOVWF       _value+1 
	CLRF        _value+0 
	MOVF        _Low_Data+0, 0 
	IORWF       _value+0, 1 
	MOVF        _Low_Data+1, 0 
	IORWF       _value+1, 1 
;DAC_VCF_SPI.c,183 :: 		while (1) {                                         // Endless loop
L_main6:
;DAC_VCF_SPI.c,185 :: 		adc_ldr = ADC_Read(0);                           // get ADC value from channel AN0 (RA0)
	CLRF        FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc_ldr+0 
	MOVF        R1, 0 
	MOVWF       _adc_ldr+1 
;DAC_VCF_SPI.c,186 :: 		if (adc_ldr < 3) {                               // Fix the minimum value of LDR detection
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main46
	MOVLW       3
	SUBWF       R0, 0 
L__main46:
	BTFSC       STATUS+0, 0 
	GOTO        L_main8
;DAC_VCF_SPI.c,187 :: 		adc_ldr = 3;
	MOVLW       3
	MOVWF       _adc_ldr+0 
	MOVLW       0
	MOVWF       _adc_ldr+1 
;DAC_VCF_SPI.c,188 :: 		}
L_main8:
;DAC_VCF_SPI.c,189 :: 		if ((PUSH_Increment) && (value < 4095)) {        // If RA3 button is pressed
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_main11
	MOVLW       15
	SUBWF       _value+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main47
	MOVLW       255
	SUBWF       _value+0, 0 
L__main47:
	BTFSC       STATUS+0, 0 
	GOTO        L_main11
L__main39:
;DAC_VCF_SPI.c,190 :: 		value++;                                       //   increment value
	INFSNZ      _value+0, 1 
	INCF        _value+1, 1 
;DAC_VCF_SPI.c,191 :: 		Write_EEPROM(value);
	MOVF        _value+0, 0 
	MOVWF       FARG_Write_EEPROM_data_+0 
	MOVF        _value+1, 0 
	MOVWF       FARG_Write_EEPROM_data_+1 
	CALL        _Write_EEPROM+0, 0
;DAC_VCF_SPI.c,192 :: 		}
	GOTO        L_main12
L_main11:
;DAC_VCF_SPI.c,194 :: 		if ((PUSH_Decrement) && (value > 0)) {         // If RA4 button is pressed
	BTFSS       RA4_bit+0, BitPos(RA4_bit+0) 
	GOTO        L_main15
	MOVLW       0
	MOVWF       R0 
	MOVF        _value+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main48
	MOVF        _value+0, 0 
	SUBLW       0
L__main48:
	BTFSC       STATUS+0, 0 
	GOTO        L_main15
L__main38:
;DAC_VCF_SPI.c,195 :: 		value--;                                     //   decrement value
	MOVLW       1
	SUBWF       _value+0, 1 
	MOVLW       0
	SUBWFB      _value+1, 1 
;DAC_VCF_SPI.c,196 :: 		Write_EEPROM(value);
	MOVF        _value+0, 0 
	MOVWF       FARG_Write_EEPROM_data_+0 
	MOVF        _value+1, 0 
	MOVWF       FARG_Write_EEPROM_data_+1 
	CALL        _Write_EEPROM+0, 0
;DAC_VCF_SPI.c,197 :: 		}
L_main15:
;DAC_VCF_SPI.c,198 :: 		}
L_main12:
;DAC_VCF_SPI.c,199 :: 		if (PUSH_Preset_maxi == 1) {                     // If RA3 and RA4 button is pressed
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_main17
	BTFSS       RA4_bit+0, BitPos(RA4_bit+0) 
	GOTO        L_main17
	MOVLW       1
	MOVWF       R1 
	GOTO        L_main16
L_main17:
	CLRF        R1 
L_main16:
	MOVF        R1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main18
;DAC_VCF_SPI.c,200 :: 		value = 4095;                                  //   set value to 4095
	MOVLW       255
	MOVWF       _value+0 
	MOVLW       15
	MOVWF       _value+1 
;DAC_VCF_SPI.c,201 :: 		Write_EEPROM(value);
	MOVLW       255
	MOVWF       FARG_Write_EEPROM_data_+0 
	MOVLW       15
	MOVWF       FARG_Write_EEPROM_data_+1 
	CALL        _Write_EEPROM+0, 0
;DAC_VCF_SPI.c,202 :: 		}
L_main18:
;DAC_VCF_SPI.c,203 :: 		if (PUSH_Preset_mini == 1) {                     // If RA5 buton is pressed
	BTFSS       RA5_bit+0, BitPos(RA5_bit+0) 
	GOTO        L_main19
;DAC_VCF_SPI.c,204 :: 		value = 0;                                     //   reset value to 0
	CLRF        _value+0 
	CLRF        _value+1 
;DAC_VCF_SPI.c,205 :: 		Write_EEPROM(value);
	CLRF        FARG_Write_EEPROM_data_+0 
	CLRF        FARG_Write_EEPROM_data_+1 
	CALL        _Write_EEPROM+0, 0
;DAC_VCF_SPI.c,206 :: 		}
L_main19:
;DAC_VCF_SPI.c,208 :: 		DAC_Output(value);                               // Send value to DAC chip
	MOVF        _value+0, 0 
	MOVWF       FARG_DAC_Output_valueDAC+0 
	MOVF        _value+1, 0 
	MOVWF       FARG_DAC_Output_valueDAC+1 
	CALL        _DAC_Output+0, 0
;DAC_VCF_SPI.c,210 :: 		if (PUSH_DAC_Delay) {
	BTFSS       RA1_bit+0, BitPos(RA1_bit+0) 
	GOTO        L_main20
;DAC_VCF_SPI.c,211 :: 		Display_speed_delay();
	CALL        _Display_speed_delay+0, 0
;DAC_VCF_SPI.c,212 :: 		++cnt;
	INFSNZ      _cnt+0, 1 
	INCF        _cnt+1, 1 
;DAC_VCF_SPI.c,214 :: 		while(PUSH_DAC_Delay);                         // attendre que le bouton soit relach
L_main21:
	BTFSS       RA1_bit+0, BitPos(RA1_bit+0) 
	GOTO        L_main22
	GOTO        L_main21
L_main22:
;DAC_VCF_SPI.c,216 :: 		}
L_main20:
;DAC_VCF_SPI.c,217 :: 		if (cnt > 5) {
	MOVLW       0
	MOVWF       R0 
	MOVF        _cnt+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main49
	MOVF        _cnt+0, 0 
	SUBLW       5
L__main49:
	BTFSC       STATUS+0, 0 
	GOTO        L_main23
;DAC_VCF_SPI.c,218 :: 		cnt = 0;
	CLRF        _cnt+0 
	CLRF        _cnt+1 
;DAC_VCF_SPI.c,219 :: 		Delay_ms(1);
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_main24:
	DECFSZ      R13, 1, 1
	BRA         L_main24
	DECFSZ      R12, 1, 1
	BRA         L_main24
	NOP
;DAC_VCF_SPI.c,220 :: 		speed_delay = 1;
	MOVLW       1
	MOVWF       _speed_delay+0 
	MOVLW       0
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,221 :: 		}
	GOTO        L_main25
L_main23:
;DAC_VCF_SPI.c,223 :: 		if (cnt == 0) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main50
	MOVLW       0
	XORWF       _cnt+0, 0 
L__main50:
	BTFSS       STATUS+0, 2 
	GOTO        L_main26
;DAC_VCF_SPI.c,224 :: 		Delay_ms(1);
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_main27:
	DECFSZ      R13, 1, 1
	BRA         L_main27
	DECFSZ      R12, 1, 1
	BRA         L_main27
	NOP
;DAC_VCF_SPI.c,225 :: 		speed_delay = 1;
	MOVLW       1
	MOVWF       _speed_delay+0 
	MOVLW       0
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,226 :: 		}
L_main26:
L_main25:
;DAC_VCF_SPI.c,227 :: 		if (cnt == 1) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main51
	MOVLW       1
	XORWF       _cnt+0, 0 
L__main51:
	BTFSS       STATUS+0, 2 
	GOTO        L_main28
;DAC_VCF_SPI.c,228 :: 		Delay_ms(10);
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_main29:
	DECFSZ      R13, 1, 1
	BRA         L_main29
	DECFSZ      R12, 1, 1
	BRA         L_main29
	NOP
;DAC_VCF_SPI.c,229 :: 		speed_delay = 10;
	MOVLW       10
	MOVWF       _speed_delay+0 
	MOVLW       0
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,230 :: 		}
L_main28:
;DAC_VCF_SPI.c,231 :: 		if (cnt == 2) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main52
	MOVLW       2
	XORWF       _cnt+0, 0 
L__main52:
	BTFSS       STATUS+0, 2 
	GOTO        L_main30
;DAC_VCF_SPI.c,232 :: 		Delay_ms(50);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       119
	MOVWF       R13, 0
L_main31:
	DECFSZ      R13, 1, 1
	BRA         L_main31
	DECFSZ      R12, 1, 1
	BRA         L_main31
	DECFSZ      R11, 1, 1
	BRA         L_main31
;DAC_VCF_SPI.c,233 :: 		speed_delay = 50;
	MOVLW       50
	MOVWF       _speed_delay+0 
	MOVLW       0
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,234 :: 		}
L_main30:
;DAC_VCF_SPI.c,235 :: 		if (cnt == 3) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main53
	MOVLW       3
	XORWF       _cnt+0, 0 
L__main53:
	BTFSS       STATUS+0, 2 
	GOTO        L_main32
;DAC_VCF_SPI.c,236 :: 		Delay_ms(250);
	MOVLW       11
	MOVWF       R11, 0
	MOVLW       38
	MOVWF       R12, 0
	MOVLW       93
	MOVWF       R13, 0
L_main33:
	DECFSZ      R13, 1, 1
	BRA         L_main33
	DECFSZ      R12, 1, 1
	BRA         L_main33
	DECFSZ      R11, 1, 1
	BRA         L_main33
	NOP
	NOP
;DAC_VCF_SPI.c,237 :: 		speed_delay = 250;
	MOVLW       250
	MOVWF       _speed_delay+0 
	MOVLW       0
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,238 :: 		}
L_main32:
;DAC_VCF_SPI.c,239 :: 		if (cnt == 4) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main54
	MOVLW       4
	XORWF       _cnt+0, 0 
L__main54:
	BTFSS       STATUS+0, 2 
	GOTO        L_main34
;DAC_VCF_SPI.c,240 :: 		Delay_ms(500);
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_main35:
	DECFSZ      R13, 1, 1
	BRA         L_main35
	DECFSZ      R12, 1, 1
	BRA         L_main35
	DECFSZ      R11, 1, 1
	BRA         L_main35
	NOP
;DAC_VCF_SPI.c,241 :: 		speed_delay = 500;
	MOVLW       244
	MOVWF       _speed_delay+0 
	MOVLW       1
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,242 :: 		}
L_main34:
;DAC_VCF_SPI.c,243 :: 		if (cnt == 5) {
	MOVLW       0
	XORWF       _cnt+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main55
	MOVLW       5
	XORWF       _cnt+0, 0 
L__main55:
	BTFSS       STATUS+0, 2 
	GOTO        L_main36
;DAC_VCF_SPI.c,244 :: 		Delay_ms(1000);
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main37:
	DECFSZ      R13, 1, 1
	BRA         L_main37
	DECFSZ      R12, 1, 1
	BRA         L_main37
	DECFSZ      R11, 1, 1
	BRA         L_main37
;DAC_VCF_SPI.c,245 :: 		speed_delay = 1000;
	MOVLW       232
	MOVWF       _speed_delay+0 
	MOVLW       3
	MOVWF       _speed_delay+1 
;DAC_VCF_SPI.c,246 :: 		}
L_main36:
;DAC_VCF_SPI.c,258 :: 		current_duty = adc_ldr * 1.5;                    // Coefficient for adjust LDR level detection
	MOVF        _adc_ldr+0, 0 
	MOVWF       R0 
	MOVF        _adc_ldr+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       64
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _Double2Byte+0, 0
	MOVF        R0, 0 
	MOVWF       _current_duty+0 
;DAC_VCF_SPI.c,259 :: 		PWM1_Set_Duty(current_duty);
	MOVF        R0, 0 
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;DAC_VCF_SPI.c,263 :: 		adc_rd = value;
	MOVF        _value+0, 0 
	MOVWF       _adc_rd+0 
	MOVF        _value+1, 0 
	MOVWF       _adc_rd+1 
;DAC_VCF_SPI.c,264 :: 		Lcd_Out(2,1,text);
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        _text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;DAC_VCF_SPI.c,265 :: 		tlong = (long)adc_rd * 5000;                     // Convert the result in millivolts
	MOVF        _adc_rd+0, 0 
	MOVWF       R0 
	MOVF        _adc_rd+1, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVWF       R3 
	MOVLW       136
	MOVWF       R4 
	MOVLW       19
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       _tlong+0 
	MOVF        R1, 0 
	MOVWF       _tlong+1 
	MOVF        R2, 0 
	MOVWF       _tlong+2 
	MOVF        R3, 0 
	MOVWF       _tlong+3 
;DAC_VCF_SPI.c,267 :: 		k = 1.221001221;
	MOVLW       1
	MOVWF       _k+0 
	MOVLW       0
	MOVWF       _k+1 
	MOVWF       _k+2 
	MOVWF       _k+3 
;DAC_VCF_SPI.c,268 :: 		tlong = (tlong / 4095) * k;                      // 0..4095 -> 0-5000mV (12-bit) --> 1,221001221E0 by step
	MOVLW       255
	MOVWF       R4 
	MOVLW       15
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Div_32x32_S+0, 0
	MOVF        R0, 0 
	MOVWF       _tlong+0 
	MOVF        R1, 0 
	MOVWF       _tlong+1 
	MOVF        R2, 0 
	MOVWF       _tlong+2 
	MOVF        R3, 0 
	MOVWF       _tlong+3 
;DAC_VCF_SPI.c,269 :: 		ch = tlong / 1000;                               // Extract volts (thousands of millivolts)
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Div_32x32_S+0, 0
	MOVF        R0, 0 
	MOVWF       _ch+0 
;DAC_VCF_SPI.c,271 :: 		ch = ((tlong / 1000) % 10) ;                     // Extract thousands of millivolts
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	MOVF        _tlong+0, 0 
	MOVWF       R0 
	MOVF        _tlong+1, 0 
	MOVWF       R1 
	MOVF        _tlong+2, 0 
	MOVWF       R2 
	MOVF        _tlong+3, 0 
	MOVWF       R3 
	CALL        _Div_32x32_S+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Div_32x32_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R10, 0 
	MOVWF       R2 
	MOVF        R11, 0 
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       _ch+0 
;DAC_VCF_SPI.c,272 :: 		Lcd_Chr(2,10,48+ch);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;DAC_VCF_SPI.c,273 :: 		ch = ((tlong / 100) % 10) ;                      // Extract hundreds of millivolts
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	MOVF        _tlong+0, 0 
	MOVWF       R0 
	MOVF        _tlong+1, 0 
	MOVWF       R1 
	MOVF        _tlong+2, 0 
	MOVWF       R2 
	MOVF        _tlong+3, 0 
	MOVWF       R3 
	CALL        _Div_32x32_S+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Div_32x32_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R10, 0 
	MOVWF       R2 
	MOVF        R11, 0 
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       _ch+0 
;DAC_VCF_SPI.c,274 :: 		Lcd_Chr_CP(48+ch);                               // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,275 :: 		ch = ((tlong / 10) % 10) ;                       // Extract tens of millivolts
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	MOVF        _tlong+0, 0 
	MOVWF       R0 
	MOVF        _tlong+1, 0 
	MOVWF       R1 
	MOVF        _tlong+2, 0 
	MOVWF       R2 
	MOVF        _tlong+3, 0 
	MOVWF       R3 
	CALL        _Div_32x32_S+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Div_32x32_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R10, 0 
	MOVWF       R2 
	MOVF        R11, 0 
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       _ch+0 
;DAC_VCF_SPI.c,276 :: 		Lcd_Chr_CP(48+ch);                               // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,277 :: 		ch = (tlong % 10) ;                              // Extract digits for millivolts
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	MOVF        _tlong+0, 0 
	MOVWF       R0 
	MOVF        _tlong+1, 0 
	MOVWF       R1 
	MOVF        _tlong+2, 0 
	MOVWF       R2 
	MOVF        _tlong+3, 0 
	MOVWF       R3 
	CALL        _Div_32x32_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R10, 0 
	MOVWF       R2 
	MOVF        R11, 0 
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       _ch+0 
;DAC_VCF_SPI.c,278 :: 		Lcd_Chr_CP(48+ch);                               // Write result in ASCII format
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;DAC_VCF_SPI.c,279 :: 		Lcd_Out_CP("mV");
	MOVLW       ?lstr10_DAC_VCF_SPI+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(?lstr10_DAC_VCF_SPI+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;DAC_VCF_SPI.c,280 :: 		}
	GOTO        L_main6
;DAC_VCF_SPI.c,281 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
